        subroutine uread(matrix, len,job,n,nnz,a,ja,ia, rhs, ierr)
        implicit none
        character (len=100):: matrix
        integer:: n, nnz, ierr, ja(*), ia(*)
        real*8:: a(*), rhs(*)
        integer:: job, len
c =============================================
c User-defined read function: 
c ---- reads the files provided by A. Soulaimani.
c Input:
c   matrix	(character) file containing names of the files with matrix input
c   len		(integer)   size of variable matrix
c   job		(integer)   flag: if 0 return the sizes only; if 1 read the 
c                           matrix information.
c Output:
c   n		(integr) numbere of unknowns
c   nnz		(integr) numbere of nonzeros
c   (a,ja,ia)	matrix in CSR format, returned only if job=1
c   rhs		(double) right-hand side -- NOT USED IN THIS VERSION
c   ierr	(integer) not equal zero if read error occurs
c
c===============================================
c local variables
c
	integer:: i, iounit=12
        character (len=200):: matrix1,reada,readja, readr
        ierr=0
        matrix1(1:len)=matrix(1:len)
c open file stating matrix locations
        open(unit=iounit,form="FORMATTED",file=matrix1,status="unknown")
        read(iounit, *,err= 10) reada  !file for real data of the matrix 
        read(iounit, *,err= 10) readja !file for integer data of the matrix 
        read(iounit, *,err= 10) readr  !file for right hand side 

c read integer matrix data
        open(unit=iounit,form="FORMATTED",file=readja,status="unknown")    
        read(iounit,*, err=11)n
        read(iounit,*, err=11)nnz
        if (job .eq. 0 ) return
c
        read(iounit,*, err=11)(ja(i),i=1,nnz)
        read(iounit,*,err= 11)n
        read(iounit,*,err= 11)(ia(i),i=1,n+1)
c
c read real values stored in unformated form
        open(unit=iounit,form="UNFORMATTED",file=reada,status="unknown")
        read(iounit, err=12) (a(i),i=1,nnz)
c
c read right hand side vector stored in unformated form
        open(unit=iounit,form="UNFORMATTED",file=readr,status="unknown")
        read(iounit, err=13) (rhs(i),i=1,n)
        return
c
 10     print *, "Error in reading inputs file", matrix1
 11     print *, "Error in reading file with integers", readja
 12     print *, "Error in reading file with real values", reada  
 13     print *, "Error in reading file with right hand side", readr
        ierr = 1
        return
        end subroutine uread
